/*

  Bastila and Cantina Bastila use force lightning at the same time.

*/

void main()
{

  object ocb = GetObjectByTag("Cantina Bastila");
  object obas = GetObjectByTag("Bastila");
  object opc = GetFirstPC();
  object odancer = GetObjectByTag("MusicRoomT021");
  object omus1 = GetObjectByTag("BithMusic01");
  object omus2 = GetObjectByTag("BithMusic02");
  object omus3 = GetObjectByTag("BithMusic03");

  if ((GetIsObjectValid(obas)==TRUE) && (GetIsObjectValid(ocb)==TRUE))
  {


    object othird = GetPartyMemberByIndex(0);
    string sthird = "";
    string spc = GetName(opc);
    string sbast = GetName(obas);

    if (GetIsObjectValid(othird)==TRUE)
    {
      sthird = GetName(othird);
      if ((sthird == spc) || (sthird == sbast))
      {
        othird = GetPartyMemberByIndex(1);
      }

      sthird = GetName(othird);
      if ((sthird == spc) || (sthird == sbast))
      {
        othird = GetPartyMemberByIndex(2);
      }
    }



    effect eVis1 =  EffectVisualEffect(VFX_PRO_LIGHTNING_S);
    effect ebeam1 = EffectBeam(VFX_BEAM_LIGHTNING_DARK_L, ocb, BODY_NODE_HAND);

    effect eVis2 =  EffectVisualEffect(VFX_PRO_LIGHTNING_S);
    effect ebeam2 = EffectBeam(VFX_BEAM_LIGHTNING_DARK_L, obas, BODY_NODE_HAND);

    AssignCommand(ocb, ClearAllActions());
    ActionPauseConversation();
    SetDialogPlaceableCamera( 13 );
    AssignCommand(ocb, ActionCastFakeSpellAtObject(FORCE_POWER_LIGHTNING, obas));

    AssignCommand(obas, ClearAllActions());
    AssignCommand(obas, ActionPauseConversation());
    AssignCommand(obas, ActionCastFakeSpellAtObject(FORCE_POWER_LIGHTNING, ocb));


    DelayCommand(1.2, ApplyEffectToObject(DURATION_TYPE_TEMPORARY, ebeam1, obas, 1.0));
    DelayCommand(1.2, ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eVis1, obas, 1.0));

    DelayCommand(1.2, ApplyEffectToObject(DURATION_TYPE_TEMPORARY, ebeam1, opc, 1.0));
    DelayCommand(1.2, ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eVis1, opc, 1.0));

    if (GetIsObjectValid(othird)==TRUE)
    {
      DelayCommand(1.2, ApplyEffectToObject(DURATION_TYPE_TEMPORARY, ebeam1, othird, 1.0));
      DelayCommand(1.2, ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eVis1, othird, 1.0));
    }


    DelayCommand(1.2, ApplyEffectToObject(DURATION_TYPE_TEMPORARY, ebeam2, ocb, 1.0));
    DelayCommand(1.2, ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eVis2, ocb, 1.0));

    DelayCommand(1.2, ApplyEffectToObject(DURATION_TYPE_TEMPORARY, ebeam2, odancer, 1.0));
    DelayCommand(1.2, ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eVis2, odancer, 1.0));

    DelayCommand(1.2, ApplyEffectToObject(DURATION_TYPE_TEMPORARY, ebeam2, omus1, 1.0));
    DelayCommand(1.2, ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eVis2, omus1, 1.0));

    DelayCommand(1.2, ApplyEffectToObject(DURATION_TYPE_TEMPORARY, ebeam2, omus2, 1.0));
    DelayCommand(1.2, ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eVis2, omus2, 1.0));

    DelayCommand(1.2, ApplyEffectToObject(DURATION_TYPE_TEMPORARY, ebeam2, omus3, 1.0));
    DelayCommand(1.2, ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eVis2, omus3, 1.0));


    DelayCommand(1.0, AssignCommand(obas, ActionPlayAnimation(ANIMATION_LOOPING_SPASM, 1.0, 1.5)));
    DelayCommand(1.0, AssignCommand(opc, ActionPlayAnimation(ANIMATION_LOOPING_SPASM, 1.0, 1.5)));

    if (GetIsObjectValid(othird)==TRUE)
      DelayCommand(1.0, AssignCommand(othird, ActionPlayAnimation(ANIMATION_LOOPING_SPASM, 1.0, 1.5)));



    DelayCommand(1.0, AssignCommand(ocb, ActionPlayAnimation(ANIMATION_LOOPING_SPASM, 1.0, 1.5)));
    DelayCommand(1.0, AssignCommand(odancer, ActionPlayAnimation(ANIMATION_LOOPING_SPASM, 1.0, 1.5)));
    DelayCommand(1.0, AssignCommand(omus1, ActionPlayAnimation(ANIMATION_LOOPING_SPASM, 1.0, 1.5)));
    DelayCommand(1.0, AssignCommand(omus2, ActionPlayAnimation(ANIMATION_LOOPING_SPASM, 1.0, 1.5)));
    DelayCommand(1.0, AssignCommand(omus3, ActionPlayAnimation(ANIMATION_LOOPING_SPASM, 1.0, 1.5)));



    effect edeath = EffectDeath(TRUE, TRUE);


    DelayCommand(2.0, ApplyEffectToObject(DURATION_TYPE_TEMPORARY, edeath, ocb));
    DelayCommand(2.0, ApplyEffectToObject(DURATION_TYPE_TEMPORARY, edeath, odancer));
    DelayCommand(2.0, ApplyEffectToObject(DURATION_TYPE_TEMPORARY, edeath, omus1));
    DelayCommand(2.0, ApplyEffectToObject(DURATION_TYPE_TEMPORARY, edeath, omus2));
    DelayCommand(2.0, ApplyEffectToObject(DURATION_TYPE_TEMPORARY, edeath, omus3));



    ActionResumeConversation();

    DelayCommand(5.0, AssignCommand(GetFirstPC(), ActionStartConversation( obas, "kkcb_bast_end2", FALSE, CONVERSATION_TYPE_CINEMATIC, TRUE )));

  }

}