/*

  Random Force Attack by NPC Bastila

*/

void main()
{

  object ocb = GetObjectByTag("Cantina Bastila");
  object obas = GetObjectByTag("Bastila");
  object opc = GetFirstPC();
  object odancer = GetObjectByTag("MusicRoomT021");
  object omus1 = GetObjectByTag("BithMusic01");
  object omus2 = GetObjectByTag("BithMusic02");
  object omus3 = GetObjectByTag("BithMusic03");
  object othird = GetPartyMemberByIndex(0);
  string sthird = "";
  string spc = GetName(opc);
  string sbast = GetName(obas);
  int irand1 = Random(6);

  if ((GetIsObjectValid(obas)==TRUE) && (GetIsObjectValid(ocb)==TRUE))
  {

    //AssignCommand(obas, ActionPauseConversation());

    //is there a third party member?
    if (GetIsObjectValid(othird)==TRUE)
    {
      sthird = GetName(othird);
      if ((sthird == spc) || (sthird == sbast))
      {
        othird = GetPartyMemberByIndex(1);
      }

      sthird = GetName(othird);
      if ((sthird == spc) || (sthird == sbast))
      {
        othird = GetPartyMemberByIndex(2);
      }
    }

    //Cantina Bastila Attacks Bastila (or Party)
    switch (irand1)
    {
      case 0:
      {
        //force storm
        effect eVis0 = EffectVisualEffect(VFX_PRO_LIGHTNING_S);
        effect ebeam0 = EffectBeam(VFX_BEAM_LIGHTNING_DARK_L, obas, BODY_NODE_HAND);

        AssignCommand(obas, ClearAllActions());
        AssignCommand(ocb, ClearAllEffects());
        AssignCommand(obas, ActionCastFakeSpellAtObject(FORCE_POWER_LIGHTNING, ocb));

        DelayCommand(1.0, ApplyEffectToObject(DURATION_TYPE_TEMPORARY, ebeam0, ocb, 2.0));
        DelayCommand(1.0, ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eVis0, ocb, 2.0));
        DelayCommand(1.0, ApplyEffectToObject(DURATION_TYPE_TEMPORARY, ebeam0, odancer, 2.0));
        DelayCommand(1.0, ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eVis0, odancer, 2.0));
        DelayCommand(1.0, ApplyEffectToObject(DURATION_TYPE_TEMPORARY, ebeam0, omus1, 2.0));
        DelayCommand(1.0, ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eVis0, omus1, 2.0));
        DelayCommand(1.0, ApplyEffectToObject(DURATION_TYPE_TEMPORARY, ebeam0, omus2, 2.0));
        DelayCommand(1.0, ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eVis0, omus2, 2.0));
        DelayCommand(1.0, ApplyEffectToObject(DURATION_TYPE_TEMPORARY, ebeam0, omus3, 2.0));
        DelayCommand(1.0, ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eVis0, omus3, 2.0));

        DelayCommand(1.0, AssignCommand(ocb, ActionPlayAnimation(ANIMATION_LOOPING_SPASM, 1.0, 1.5)));
        DelayCommand(1.0, AssignCommand(odancer, ActionPlayAnimation(ANIMATION_LOOPING_SPASM, 1.0, 1.5)));
        DelayCommand(1.0, AssignCommand(omus1, ActionPlayAnimation(ANIMATION_LOOPING_SPASM, 1.0, 1.5)));
        DelayCommand(1.0, AssignCommand(omus2, ActionPlayAnimation(ANIMATION_LOOPING_SPASM, 1.0, 1.5)));
        DelayCommand(1.0, AssignCommand(omus3, ActionPlayAnimation(ANIMATION_LOOPING_SPASM, 1.0, 1.5)));
      }
      break;
      
      case 1:
      {
        //death field
        effect eVis1 = EffectVisualEffect(VFX_PRO_DEATH_FIELD);
        effect ebeam1 = EffectBeam(VFX_BEAM_DEATH_FIELD_TENTACLE, obas, BODY_NODE_HAND);

        AssignCommand(obas, ClearAllActions());
        AssignCommand(ocb, ClearAllEffects());
        AssignCommand(obas, ActionCastFakeSpellAtObject(FORCE_POWER_DEATH_FIELD, ocb));

        DelayCommand(1.0, ApplyEffectToObject(DURATION_TYPE_TEMPORARY, ebeam1, ocb, 2.0));
        DelayCommand(1.0, ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eVis1, ocb, 2.0));
        DelayCommand(1.0, ApplyEffectToObject(DURATION_TYPE_TEMPORARY, ebeam1, odancer, 2.0));
        DelayCommand(1.0, ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eVis1, odancer, 2.0));
        DelayCommand(1.0, ApplyEffectToObject(DURATION_TYPE_TEMPORARY, ebeam1, omus1, 2.0));
        DelayCommand(1.0, ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eVis1, omus1, 2.0));
        DelayCommand(1.0, ApplyEffectToObject(DURATION_TYPE_TEMPORARY, ebeam1, omus2, 2.0));
        DelayCommand(1.0, ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eVis1, omus2, 2.0));
        DelayCommand(1.0, ApplyEffectToObject(DURATION_TYPE_TEMPORARY, ebeam1, omus3, 2.0));
        DelayCommand(1.0, ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eVis1, omus3, 2.0));

        DelayCommand(1.0, AssignCommand(ocb, ActionPlayAnimation(ANIMATION_LOOPING_SPASM, 1.0, 1.5))); 
        DelayCommand(1.0, AssignCommand(odancer, ActionPlayAnimation(ANIMATION_LOOPING_SPASM, 1.0, 1.5))); 
        DelayCommand(1.0, AssignCommand(omus1, ActionPlayAnimation(ANIMATION_LOOPING_SPASM, 1.0, 1.5))); 
        DelayCommand(1.0, AssignCommand(omus2, ActionPlayAnimation(ANIMATION_LOOPING_SPASM, 1.0, 1.5))); 
        DelayCommand(1.0, AssignCommand(omus3, ActionPlayAnimation(ANIMATION_LOOPING_SPASM, 1.0, 1.5))); 
      }
      break;

      case 2:
      {
        //force wave
        effect eVis2 = EffectVisualEffect(VFX_IMP_FORCE_PUSH);
        effect eVis2a = EffectForcePushed();
        
        AssignCommand(obas, ClearAllActions());
        AssignCommand(ocb, ClearAllEffects());
        AssignCommand(obas, ActionCastFakeSpellAtObject(FORCE_POWER_FORCE_WAVE, ocb));

        ApplyEffectAtLocation(DURATION_TYPE_INSTANT, EffectVisualEffect(VFX_FNF_FORCE_WAVE), GetLocation(OBJECT_SELF));

        DelayCommand(1.0, ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eVis2, ocb, 2.0));  
        DelayCommand(1.5, ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eVis2a, ocb, 2.0));  
        DelayCommand(1.0, ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eVis2, odancer, 2.0));
        DelayCommand(1.5, ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eVis2a, odancer, 2.0));
        DelayCommand(1.0, ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eVis2, omus1, 2.0));
        DelayCommand(1.5, ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eVis2a, omus1, 2.0));
        DelayCommand(1.0, ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eVis2, omus2, 2.0));
        DelayCommand(1.5, ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eVis2a, omus2, 2.0));
        DelayCommand(1.0, ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eVis2, omus3, 2.0));
        DelayCommand(1.5, ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eVis2a, omus3, 2.0));
      
        vector vpos1 = Vector(107.02, 133.69, 0.0);
        location lpos1 = Location(vpos1, 100.0);

        vector vpos2 = Vector(109.78, 133.23, 0.0);
        location lpos2 = Location(vpos2, 100.0);

        vector vpos3 = Vector(112.28, 134.86, 0.0);
        location lpos3 = Location(vpos3, 100.0);

        AssignCommand(obas, ActionForceMoveToLocation(lpos1,TRUE,1.0));
        AssignCommand(opc, ActionForceMoveToLocation(lpos2,TRUE,1.0));
        if (GetIsObjectValid(othird)==TRUE)
          AssignCommand(othird, ActionForceMoveToLocation(lpos3,TRUE,1.0));
      }
      break;

      case 3:
      {
        //force whirlwind
        effect eVis3 = EffectWhirlWind();
        eVis3 = EffectLinkEffects(eVis3, EffectVisualEffect(VFX_IMP_FORCE_WHIRLWIND));
        eVis3 = EffectLinkEffects(eVis3, EffectVisualEffect(VFX_DUR_FORCE_WHIRLWIND));

        AssignCommand(obas, ClearAllActions());
        AssignCommand(ocb, ClearAllEffects());
        AssignCommand(obas, ActionCastFakeSpellAtObject(FORCE_POWER_FORCE_WHIRLWIND, ocb));

        DelayCommand(1.0, ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eVis3, ocb, 2.0));
      }
      break;

      case 4:
      {
        //force choke
        effect eVis4 = EffectChoke();

        AssignCommand(obas, ClearAllActions());
        AssignCommand(ocb, ClearAllEffects());
        AssignCommand(obas, ActionCastFakeSpellAtObject(FORCE_POWER_CHOKE, ocb));

        DelayCommand(1.0, ApplyEffectToObject(DURATION_TYPE_INSTANT, EffectVisualEffect(VFX_IMP_CHOKE), obas));
        DelayCommand(1.0, ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eVis4, ocb, 2.0));      
      }
      break;

      case 5:
      {
        //insanity
        effect eVis5 = EffectHorrified();
        eVis5 = EffectLinkEffects(eVis5, EffectVisualEffect(1043));

        AssignCommand(obas, ClearAllActions());
        AssignCommand(ocb, ClearAllEffects());
        AssignCommand(obas, ActionCastFakeSpellAtObject(FORCE_POWER_INSANITY, ocb));

        DelayCommand(1.0, ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eVis5, ocb, 2.0));
        DelayCommand(1.0, ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eVis5, odancer, 2.0));
        DelayCommand(1.0, ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eVis5, omus1, 2.0));
        DelayCommand(1.0, ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eVis5, omus2, 2.0));
        DelayCommand(1.0, ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eVis5, omus3, 2.0));
      }
      break;
    }

    //AssignCommand(obas, ActionWait(2.0));
    //AssignCommand(obas, ActionResumeConversation());

  }

}