/*

  kill everybody

*/

#include "k_inc_debug"
#include "k_inc_utility"

void main()
{

  object obas = GetObjectByTag("Cantina Bastila");
  object ocar = GetObjectByTag("Bastila");
  object odancer = GetObjectByTag("MusicRoomT021");
  object omus1 = GetObjectByTag("BithMusic01");
  object omus2 = GetObjectByTag("BithMusic02");
  object omus3 = GetObjectByTag("BithMusic03");

  if ((GetIsObjectValid(obas)==TRUE) && (GetIsObjectValid(ocar)==TRUE))
  {

    AssignCommand(ocar, ClearAllActions());

    SetDialogPlaceableCamera( 13 );
    ActionPauseConversation();

    AssignCommand(ocar, ActionCastFakeSpellAtObject(FORCE_POWER_LIGHTNING, obas));

    effect eVis =  EffectVisualEffect(VFX_PRO_LIGHTNING_S);
    effect ebeam = EffectBeam(VFX_BEAM_LIGHTNING_DARK_L, ocar, BODY_NODE_HAND);

    DelayCommand(1.2, ApplyEffectToObject(DURATION_TYPE_TEMPORARY, ebeam, obas, 0.8));
    DelayCommand(1.2, ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eVis, obas, 0.8));

    DelayCommand(1.2, ApplyEffectToObject(DURATION_TYPE_TEMPORARY, ebeam, odancer, 0.8));
    DelayCommand(1.2, ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eVis, odancer, 0.8));

    DelayCommand(1.2, ApplyEffectToObject(DURATION_TYPE_TEMPORARY, ebeam, omus1, 0.8));
    DelayCommand(1.2, ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eVis, omus1, 0.8));

    DelayCommand(1.2, ApplyEffectToObject(DURATION_TYPE_TEMPORARY, ebeam, omus2, 0.8));
    DelayCommand(1.2, ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eVis, omus2, 0.8));

    DelayCommand(1.2, ApplyEffectToObject(DURATION_TYPE_TEMPORARY, ebeam, omus3, 0.8));
    DelayCommand(1.2, ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eVis, omus3, 0.8));

    effect edeath = EffectDeath(TRUE, TRUE);

    DelayCommand(2.0, ApplyEffectToObject(DURATION_TYPE_TEMPORARY, edeath, obas));
    DelayCommand(2.0, ApplyEffectToObject(DURATION_TYPE_TEMPORARY, edeath, odancer));
    DelayCommand(2.0, ApplyEffectToObject(DURATION_TYPE_TEMPORARY, edeath, omus1));
    DelayCommand(2.0, ApplyEffectToObject(DURATION_TYPE_TEMPORARY, edeath, omus2));
    DelayCommand(2.0, ApplyEffectToObject(DURATION_TYPE_TEMPORARY, edeath, omus3));

    ActionResumeConversation();

    DelayCommand(5.0, AssignCommand(GetFirstPC(), ActionStartConversation( ocar, "kkcb_bast_end", FALSE, CONVERSATION_TYPE_CINEMATIC, TRUE )));

  }

}