/*

  Random Force Attack by Cantina Bastila

*/

void main()
{

  object ocb = GetObjectByTag("Cantina Bastila");
  object obas = GetObjectByTag("Bastila");
  object opc = GetFirstPC();
  object odancer = GetObjectByTag("MusicRoomT021");
  object omus1 = GetObjectByTag("BithMusic01");
  object omus2 = GetObjectByTag("BithMusic02");
  object omus3 = GetObjectByTag("BithMusic03");
  object othird = GetPartyMemberByIndex(0);
  string sthird = "";
  string spc = GetName(opc);
  string sbast = GetName(obas);
  int irand1 = Random(6);

  if ((GetIsObjectValid(obas)==TRUE) && (GetIsObjectValid(ocb)==TRUE))
  {

    
    //AssignCommand(ocb, ActionPauseConversation());
    //SetDialogPlaceableCamera(13);
    //move pc

    //is there a third party member?
    if (GetIsObjectValid(othird)==TRUE)
    {
      sthird = GetName(othird);
      if ((sthird == spc) || (sthird == sbast))
      {
        othird = GetPartyMemberByIndex(1);
      }

      sthird = GetName(othird);
      if ((sthird == spc) || (sthird == sbast))
      {
        othird = GetPartyMemberByIndex(2);
      }
    }

    //Cantina Bastila Attacks Bastila (or Party)
    switch (irand1)
    {
      case 0:
      {
        //force storm (Cast as force lightning)

        AssignCommand(ocb, ClearAllActions());
        AssignCommand(ocb, ClearAllEffects());
        AssignCommand(ocb, ActionCastFakeSpellAtObject(FORCE_POWER_LIGHTNING, obas));

        effect eVis0 = EffectVisualEffect(VFX_PRO_LIGHTNING_S);
        effect ebeam0 = EffectBeam(VFX_BEAM_LIGHTNING_DARK_L, ocb, BODY_NODE_HAND);

        DelayCommand(1.0, ApplyEffectToObject(DURATION_TYPE_TEMPORARY, ebeam0, obas, 2.0));
        DelayCommand(1.0, ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eVis0, obas, 2.0));

        DelayCommand(1.0, ApplyEffectToObject(DURATION_TYPE_TEMPORARY, ebeam0, opc, 2.0));
        DelayCommand(1.0, ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eVis0, opc, 2.0));

        if (GetIsObjectValid(othird)==TRUE)
        {
          DelayCommand(1.0, ApplyEffectToObject(DURATION_TYPE_TEMPORARY, ebeam0, othird, 2.0));
          DelayCommand(1.0, ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eVis0, othird, 2.0));
        }

        DelayCommand(1.0, AssignCommand(obas, ActionPlayAnimation(ANIMATION_LOOPING_SPASM, 1.0, 1.5)));
        DelayCommand(1.0, AssignCommand(opc, ActionPlayAnimation(ANIMATION_LOOPING_SPASM, 1.0, 1.5)));
        if (GetIsObjectValid(othird)==TRUE)
        {        
          DelayCommand(1.0, AssignCommand(othird, ActionPlayAnimation(ANIMATION_LOOPING_SPASM, 1.0, 1.5)));
        }
      }
      break;
      
      case 1:
      {
        //death field
        effect eVis1 = EffectVisualEffect(VFX_PRO_DEATH_FIELD);
        effect ebeam1 = EffectBeam(VFX_BEAM_DEATH_FIELD_TENTACLE, ocb, BODY_NODE_HAND);

        AssignCommand(ocb, ClearAllActions());
        AssignCommand(ocb, ClearAllEffects());
        AssignCommand(ocb, ActionCastFakeSpellAtObject(FORCE_POWER_LIGHTNING, obas));

        DelayCommand(1.0, ApplyEffectToObject(DURATION_TYPE_TEMPORARY, ebeam1, obas, 2.0));
        DelayCommand(1.0, ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eVis1, obas, 2.0));

        DelayCommand(1.0, ApplyEffectToObject(DURATION_TYPE_TEMPORARY, ebeam1, opc, 2.0));
        DelayCommand(1.0, ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eVis1, opc, 2.0));

        if (GetIsObjectValid(othird)==TRUE)
        {
          DelayCommand(1.0, ApplyEffectToObject(DURATION_TYPE_TEMPORARY, ebeam1, othird, 2.0));
          DelayCommand(1.0, ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eVis1, othird, 2.0));
        } 

        DelayCommand(1.0, AssignCommand(obas, ActionPlayAnimation(ANIMATION_LOOPING_SPASM, 1.0, 1.5)));
        DelayCommand(1.0, AssignCommand(opc, ActionPlayAnimation(ANIMATION_LOOPING_SPASM, 1.0, 1.5)));
        if (GetIsObjectValid(othird)==TRUE)
        {        
          DelayCommand(1.0, AssignCommand(othird, ActionPlayAnimation(ANIMATION_LOOPING_SPASM, 1.0, 1.5)));
        }   
      }
      break;

      case 2:
      {
        //drain life
        effect eVis2 = EffectVisualEffect(VFX_BEAM_DRAIN_LIFE);
        eVis2 = EffectLinkEffects(eVis2, EffectCutSceneHorrified());

        AssignCommand(ocb, ClearAllActions());
        AssignCommand(ocb, ClearAllEffects());
        AssignCommand(ocb, ActionCastFakeSpellAtObject(FORCE_POWER_LIGHTNING, obas));

        DelayCommand(0.5, ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eVis2, obas, 2.0));
      }
      break;

      case 3:
      {
        //force whirlwind
        effect eVis3 = EffectWhirlWind();
        eVis3 = EffectLinkEffects(eVis3, EffectVisualEffect(VFX_IMP_FORCE_WHIRLWIND));
        eVis3 = EffectLinkEffects(eVis3, EffectVisualEffect(VFX_DUR_FORCE_WHIRLWIND));

        AssignCommand(ocb, ClearAllActions());
        AssignCommand(ocb, ClearAllEffects());
        AssignCommand(ocb, ActionCastFakeSpellAtObject(FORCE_POWER_FORCE_WHIRLWIND, obas));

        DelayCommand(1.0, ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eVis3, obas, 2.0));
      }
      break;

      case 4:
      {
        //force choke
        effect eVis4 = EffectChoke();

        AssignCommand(ocb, ClearAllActions());
        AssignCommand(ocb, ClearAllEffects());
        AssignCommand(ocb, ActionCastFakeSpellAtObject(FORCE_POWER_CHOKE, obas));

        DelayCommand(1.0, ApplyEffectToObject(DURATION_TYPE_INSTANT, EffectVisualEffect(VFX_IMP_CHOKE), obas));
        DelayCommand(1.0, ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eVis4, obas, 2.0));      
      }
      break;

      case 5:
      {
        //insanity
        effect eVis5 = EffectCutSceneHorrified();
        eVis5 = EffectLinkEffects(eVis5, EffectVisualEffect(1043));

        AssignCommand(ocb, ClearAllActions());
        AssignCommand(ocb, ClearAllEffects());
        AssignCommand(ocb, ActionCastFakeSpellAtObject(FORCE_POWER_INSANITY, obas));

        DelayCommand(1.0, ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eVis5, obas, 2.0));

        DelayCommand(1.0, ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eVis5, opc, 2.0));

        if ((GetIsObjectValid(othird)==TRUE) && (GetRacialType(othird) == RACIAL_TYPE_HUMAN)) 
        {
          DelayCommand(1.0, ApplyEffectToObject(DURATION_TYPE_TEMPORARY, eVis5, othird, 2.0));
        }
      }
      break;

    }

    //AssignCommand(ocb, ActionWait(2.0));
    //AssignCommand(ocb, ActionResumeConversation());

  }

}