/*

// Looping animation constants.
int ANIMATION_LOOPING_PAUSE         = 0;
int ANIMATION_LOOPING_PAUSE2        = 1;
int ANIMATION_LOOPING_LISTEN        = 2;
int ANIMATION_LOOPING_MEDITATE      = 3;
int ANIMATION_LOOPING_WORSHIP       = 4;
//int ANIMATION_LOOPING_LOOK_FAR    = 5;
//int ANIMATION_LOOPING_SIT_CHAIR   = 6;
//int ANIMATION_LOOPING_SIT_CROSS   = 7;
int ANIMATION_LOOPING_TALK_NORMAL   = 5;
int ANIMATION_LOOPING_TALK_PLEADING = 6;
int ANIMATION_LOOPING_TALK_FORCEFUL = 7;
int ANIMATION_LOOPING_TALK_LAUGHING = 8;
int ANIMATION_LOOPING_TALK_SAD      = 9;
int ANIMATION_LOOPING_GET_LOW       = 10;
int ANIMATION_LOOPING_GET_MID       = 11;
int ANIMATION_LOOPING_PAUSE_TIRED   = 12;
int ANIMATION_LOOPING_PAUSE_DRUNK   = 13;
int ANIMATION_LOOPING_FLIRT         = 14;
int ANIMATION_LOOPING_USE_COMPUTER  = 15;
int ANIMATION_LOOPING_DANCE         = 16;
int ANIMATION_LOOPING_DANCE1        = 17;
int ANIMATION_LOOPING_HORROR        = 18;
int ANIMATION_LOOPING_READY         = 19;
int ANIMATION_LOOPING_DEACTIVATE    = 20;
int ANIMATION_LOOPING_SPASM         = 21;
int ANIMATION_LOOPING_SLEEP         = 22;
int ANIMATION_LOOPING_PRONE         = 23;
int ANIMATION_LOOPING_PAUSE3        = 24;
int ANIMATION_LOOPING_WELD      = 25;
int ANIMATION_LOOPING_DEAD      = 26;
int ANIMATION_LOOPING_TALK_INJURED  = 27;
int ANIMATION_LOOPING_LISTEN_INJURED = 28;
int ANIMATION_LOOPING_TREAT_INJURED = 29;
int ANIMATION_LOOPING_DEAD_PRONE    = 30;
int ANIMATION_LOOPING_KNEEL_TALK_ANGRY = 31;
int ANIMATION_LOOPING_KNEEL_TALK_SAD   = 32;

// NOTE: Choke is really a looping animation.  The fire and forget constant has
//       been left in because it has already been used in many places.  Please
//       use this constant from now on.
int ANIMATION_LOOPING_CHOKE                    = 116;

// Fire and forget animation constants.
int ANIMATION_FIREFORGET_HEAD_TURN_LEFT     = 100;
int ANIMATION_FIREFORGET_HEAD_TURN_RIGHT    = 101;
int ANIMATION_FIREFORGET_PAUSE_SCRATCH_HEAD = 102;
int ANIMATION_FIREFORGET_PAUSE_BORED        = 103;
int ANIMATION_FIREFORGET_SALUTE             = 104;
int ANIMATION_FIREFORGET_BOW                = 105;
//int ANIMATION_FIREFORGET_STEAL            = 106;
int ANIMATION_FIREFORGET_GREETING           = 106;
int ANIMATION_FIREFORGET_TAUNT              = 107;
int ANIMATION_FIREFORGET_VICTORY1           = 108;
int ANIMATION_FIREFORGET_VICTORY2           = 109;
int ANIMATION_FIREFORGET_VICTORY3           = 110;
//int ANIMATION_FIREFORGET_READ             = 111;
int ANIMATION_FIREFORGET_INJECT             = 112;
int ANIMATION_FIREFORGET_USE_COMPUTER       = 113;
int ANIMATION_FIREFORGET_PERSUADE           = 114;
int ANIMATION_FIREFORGET_ACTIVATE           = 115;
// NOTE: Please do not use this choke constant anymore.  The choke is not a fire
//       and forget animation.  The looping choke constant above should be used
//       instead.
int ANIMATION_FIREFORGET_CHOKE              = 116;
int ANIMATION_FIREFORGET_THROW_HIGH         = 117;
int ANIMATION_FIREFORGET_THROW_LOW          = 118;
int ANIMATION_FIREFORGET_CUSTOM01           = 119;
int ANIMATION_FIREFORGET_TREAT_INJURED      = 120;

*/

void main()
{

  object obas = GetObjectByTag("Cantina Bastila");
  object ocar = GetObjectByTag("Carth");
  object opc = GetFirstPC();

  if ((GetIsObjectValid(obas)==TRUE) && (GetIsObjectValid(ocar)==TRUE))
  {

    AssignCommand(ocar, ClearAllActions());
    PlaySound("p_carth_bat6");
    DelayCommand(2.0, AssignCommand(ocar, ActionPlayAnimation(ANIMATION_FIREFORGET_TAUNT, 1.0, 7.0)));
    //DelayCommand(3.0, AssignCommand(ocar, CutsceneAttack(obas, 236, 

  }

}